/*
  Written on a HP-UX platform but may work on other things. :)

  (C) Copyright 1996 Tom Crawford. Permission is given to copy
  and use, as long as this copyright notice is retained.

  Email me:- se2tc@dmu.ac.uk with any comments.
*/

#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <math.h>
#include "xwin.h"

#define BackCol 0
#define StarCol 1
#define ButCol 2
#define HiCol 3

/* can change the following defines */
#define NumStars 150
#define BoxXDis 600
#define BoxYDis 600
#define BoxZDis 600
#define Xpos 320
#define Ypos 240 /* half of screen width,weight */

typedef struct {
  double x,y,z;
} xyzpos;

XPoint a[4][3];
xyzpos b[NumStars],c[NumStars];

XArc d[NumStars],e[NumStars];

Window  win;
GC      gc1;
Pixmap  pix;
int     Quit=0,Speed=4;
char    keys[32],old[32];
double  r1=0.0,r2=0.0;
txwin xgh;

void setup();
void events();
void shutdn();

void main()
{
  setup();
  events();
  shutdn();
}

/**********************************************/

int mystrcmp()
{
  int i=0,l;
  for(l=0; l<32; l++) if(keys[l]!=old[l]) i=1;
  return(i);
}

void mystrcpy()
{
  int l;
  for(l=0; l<32; l++) old[l]=keys[l];
}

void clrscr()
{
  XSetForeground(xgh.display, gc1, BackCol);
  XFillRectangle(xgh.display,pix,gc1,0,0,640,480);
}

void setup()
{
  int l;

  xgh = xwincreate(NULL);
  xwinloadmap(&xgh,DefaultColormap(xgh.display,xgh.screen),0,255);

  xwinrgb2col(StarCol,255,255,255);
  xwinrgb2col(BackCol,0,0,0);
  xwinrgb2col(ButCol,155,0,0);
  xwinrgb2col(HiCol,255,0,0);

  xwinflushmap(&xgh,0,255);
  
  if (xgh.display == NULL)
  {
    fprintf(stderr,"Unable to open display.\n");
    exit(1);
  }

  win = xwinopen(&xgh, "Tom", "Tom",
                            640, 480, 640, 480, 640, 480, 1, 0, 0, 0);
  gc1 = xwinopengc(&xgh, win);
  pix = xwinopenpix(&xgh, 640, 480);

  srand(getpid()*time((long *) 0));

  for(l=0; l<NumStars; l++)
  {
    c[l].x=(rand()%BoxXDis)-(BoxXDis / 2);
    c[l].y=(rand()%BoxYDis)-(BoxYDis / 2);
    c[l].z=(rand()%BoxZDis)-(BoxZDis / 2);

    b[l]=c[l];

    d[l].width=10;
    d[l].height=10;
    d[l].angle1=0;
    d[l].angle2=23040; /* 64*360 */
  }

  a[0][0].x=602; a[0][0].y=445;
  a[0][1].x=617; a[0][1].y=460;
  a[0][2].x=602; a[0][2].y=475;

  a[1][0].x=604; a[1][0].y=443;
  a[1][1].x=634; a[1][1].y=443;
  a[1][2].x=619; a[1][2].y=458;

  a[2][0].x=636; a[2][0].y=445;
  a[2][1].x=621; a[2][1].y=460;
  a[2][2].x=636; a[2][2].y=475;

  a[3][0].x=604; a[3][0].y=477;
  a[3][1].x=634; a[3][1].y=477;
  a[3][2].x=619; a[3][2].y=462;

  clrscr();
}

void shutdn()
{
  /*XUngrabServer(xgh.display);*/
  xwinclose(&xgh, win);
  xwinremove(&xgh);
}

void rotatex(double r)
{
  double ry,rz;
  int l;
  for(l=0; l<NumStars; l++)
  {
    ry=(c[l].y * cos(r)) - (c[l].z * sin(r));
    rz=(c[l].y * sin(r)) + (c[l].z * cos(r));
    c[l].y=ry;
    c[l].z=rz;
  }
}

void rotatey(double r)
{
  double rx,rz;
  int l;
  for(l=0; l<NumStars; l++)
  {
    rx=(c[l].x * cos(r)) + (c[l].z * sin(r));
    rz=(c[l].z * cos(r)) - (c[l].x * sin(r));
    c[l].x=rx;
    c[l].z=rz;
  }
}

void rotatez(double r)
{
  double rx,ry;
  int l;
  for(l=0; l<NumStars; l++)
  {
    rx=(c[l].x * cos(r)) - (c[l].y * sin(r));
    ry=(c[l].x * sin(r)) + (c[l].y * cos(r));
    c[l].x=rx;
    c[l].y=ry;
  }
}

void calc()
{
  int l;

  for(l=0; l<NumStars; l++)
  {
    b[l].z+=Speed;
    if(b[l].z > (BoxZDis / 2))
      b[l].z-=BoxZDis;
    if(b[l].z < (-(BoxZDis / 2)))
      b[l].z+=BoxZDis;
  }
}

void draw()
{
  int l;
  double x,y,z;

  for(l=0; l<NumStars; l++)
  {
    x=c[l].x;
    y=c[l].y;
    z=c[l].z;
    e[l]=d[l];

    d[l].width= (z / 150) + 6;
    d[l].height=d[l].width;

    d[l].x=x+((x*z)*0.002)+Xpos;
    d[l].y=y+((y*z)*0.002)+Ypos;
  }

  XSetForeground(xgh.display,gc1,BackCol);
  XFillArcs(xgh.display,pix,gc1,e,NumStars);

  XSetForeground(xgh.display,gc1,StarCol);
  XFillArcs(xgh.display,pix,gc1,d,NumStars);

  XSetForeground(xgh.display,gc1,ButCol);
  for(l=0; l<4; l++)
  {
    XFillPolygon(xgh.display,pix,gc1,a[l],3,Convex,CoordModeOrigin);
  }
}

void events()
{
  int l;
  while(!Quit)
  {
    calc();

    rotatex(r1);
    rotatey(r2);
    draw();

    XQueryKeymap(xgh.display, keys);

    if(keys[7] & 64)
      Quit=1;

    if(keys[12] & 16 && Speed < 20)
      Speed++;

    if(keys[12] & 8 && Speed > -20)
      Speed--;

    for(l=0; l<NumStars; l++)
      c[l]=b[l];

    XSetForeground(xgh.display,gc1,HiCol);
    if(keys[16] &  16) {
      r2+=0.02;
      XFillPolygon(xgh.display,pix,gc1,a[0],3,Convex,CoordModeOrigin);
    }
    if(keys[16] & 128) {
      r2-=0.02;
      XFillPolygon(xgh.display,pix,gc1,a[2],3,Convex,CoordModeOrigin);
    }
    if(keys[16] &  64) {
      r1+=0.02;
      XFillPolygon(xgh.display,pix,gc1,a[1],3,Convex,CoordModeOrigin);
    }
    if(keys[16] &  32) {
      r1-=0.02;
      XFillPolygon(xgh.display,pix,gc1,a[3],3,Convex,CoordModeOrigin);
    }

    if(keys[16] &   2)
    {
      Speed=0;
      r1=r2=0; 
    }
    XCopyArea(xgh.display,pix,win,gc1,0,0,640,480,0,0);
    XSync(xgh.display,0);
  }
}
