#ifndef	GRAPHICS_H
#define	GRAPHICS_H

#include <X11/Xlib.h>
#include <X11/Xutil.h>

typedef struct
{
  Display        *display;
  int             screen;
  int             root;
  int             foreground;
  int             background;
  unsigned int    depth;
  Font            currentfont;
  Pixmap          icon;
  Colormap        colormap;
  Visual         *visual;
} txwin;

extern void xwinflushmap(txwin *xw, int start, int end);
extern void xwincreatespec();
extern txwin xwincreate(char *dispname);
extern void xwinremove(txwin *xw);
extern Window xwinopen(txwin *xw,char *windname,char *iconname, 
 int width,int height,int maxwidth,int maxheight,int minwidth,int minheight,
 unsigned int class,unsigned long background,int xpos,int ypos);
extern void xwinclose(txwin *xw, Window old);
extern GC xwinopengc(txwin *xw, Window window);
extern void xwinfreegc(txwin *xw, GC old);
extern Pixmap xwinopenpix(txwin *xw, int width, int height);
extern void xwinclosepix(txwin *xw, Pixmap old);
extern void xwincycledn(int start, int end);
extern void xwincycleup(int start, int end);
extern void xwinfadedn(int start, int end);
extern void xwinloadmap(txwin *xw, Colormap colormap, int start, int end);
extern void xwinrgb2col(int colornumber, int red, int green, int blue);
#endif
